////////////////////////////////////////////////////////////////////////////////
///////   Copyright 1992, Silicon Graphics, Inc.  All Rights Reserved.   ///////
//                                                                            //
// This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;     //
// the contents of this file may not be disclosed to third parties, copied    //
// or duplicated in any form, in whole or in part, without the prior written  //
// permission of Silicon Graphics, Inc.                                       //
//                                                                            //
// RESTRICTED RIGHTS LEGEND:                                                  //
// Use,duplication or disclosure by the Government is subject to restrictions //
// as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data     //
// and Computer Software clause at DFARS 252.227-7013, and/or in similar or   //
// successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -    //
// rights reserved under the Copyright Laws of the United States.             //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#ifndef VKQUESTIONDIALOG_H
#define VKQUESTIONDIALOG_H

#include <Vk/VkDialogManager.h>

class VkQuestionDialog : public VkDialogManager {

  public:
    
    VkQuestionDialog(const char* name) : VkDialogManager(name) { }
   ~VkQuestionDialog();

  protected:

    virtual Widget createDialog(Widget);
    void apply (Widget w, XtPointer);

  private:

    // This class is not intended to be copied.  Strangers will get a
    // compile-time error.  Because there is no implementing code, friends
    // and inadvertant local use will get an ld-time error.  If a copy
    // constructor or operator= is ever needed, simply write them and
    // make these entries public.
    VkQuestionDialog(const VkQuestionDialog&);
    VkQuestionDialog &operator= (const VkQuestionDialog&);
};

extern VkQuestionDialog *getTheQuestionDialog();

#if _VK_MAJOR > 1
extern VkQuestionDialog *getAppQuestionDialog(VkComponent *comp);
    
// WARNING... [ this macro is only valid for single screen apps ]
//
#define theQuestionDialog getAppQuestionDialog(NULL)

#else
    
#define theQuestionDialog getTheQuestionDialog()
#endif /* _VK_MAJOR > 1 */

#endif


