#ifndef _SGIAPI_H
#define _SGIAPI_H

#if defined(_SGIMOTIF) && defined(_SGIMOTIFAPI)

#ifdef __cplusplus
extern "C" {
#endif

/* CascadeB.h */
/*  K.Lee - Resource definitions for SGI "menu bar repeat" extension
 *  set XmNmenuBarRepeatTimeout to >0 (milliseconds) to enable
 *  double-click repeat feature
 */
#ifndef SgNmenuBarRepeatTimeout
#define SgNmenuBarRepeatTimeout "menuBarRepeatTimeout"
#endif
#ifndef SgCMenuBarRepeatTimeout
#define SgCMenuBarRepeatTimeout "MenuBarRepeatTimeout"
#endif

/* FileSB.h */

#ifndef SgDIALOG_FINDER
#define SgDIALOG_FINDER 7931
#endif
  
#define SgDIALOG_VIEWER 100

typedef enum _SgViewerMode
{  
  SgVIEWER_NEVER,
  SgVIEWER_NONE,
  SgVIEWER_AUTOMATIC,
  SgVIEWER_EXPLICIT
} SgViewerMode;

/* MwmUtil.h */
#ifndef MWM_FUNC_QUIT_APP	
#define MWM_FUNC_QUIT_APP       (1L << 23)
#endif
#ifndef MWM_INFO_STARTUP_SGI
#define MWM_INFO_STARTUP_SGI    (1L << 2)
#endif
#ifndef _XA_WM_QUIT_APP
#define _XA_WM_QUIT_APP         "_WM_QUIT_APP"
#endif
#ifndef _XA_SGI_TELL_WM
#define _XA_SGI_TELL_WM         "_SGI_TELL_WM"
#endif

/* ScrollBar.h */
#ifndef SgNarrowsAdjacent
#define SgNarrowsAdjacent "arrowAdjacent"
#endif

#ifndef SgCarrowLayout
#define SgCarrowLayout "ArrowAdjacent"
#endif

#ifndef SgRArrowType
#define SgRArrowType "ArrowType"
#endif

#ifndef SgNarrowsType
#define SgNarrowsType "arrowsType"
#endif

/* SgStrDefs.h */
#ifndef SgRIndPixel
#define SgRIndPixel "IndPixel"
#endif
#ifndef SgRSelectPixel
#define SgRSelectPixel "SelectPixel"
#endif
#ifndef SgRArrowType
#define SgRArrowType "ArrowType"
#endif
#ifndef SgNindicatorBackground
#define SgNindicatorBackground "indicatorBackground"
#endif


/* TextF.h */
#ifndef SgCR_POST_MOTION
#define SgCR_POST_MOTION 5296
#endif

/* ToggleB.h */
extern Pixel SgGetLocatePixel( Widget w, Pixel bkg_pixel); 


/* Xm.h */

enum{ SgNOT_ADJACENT,  SgLEFT_ADJACENT, SgRIGHT_ADJACENT ,
      SgTOP_ADJACENT,  SgBOTTOM_ADJACENT };

enum { SgNORMAL_ARROWS, SgROTATE_ARROWS, SgNO_THUMB_WHEN_EMPTY};

/* Depreciated Symbols */

#ifdef _SGIMOTIF_OBSOLETE_API

#define Xm3D_N_OF_MANY Sg3D_N_OF_MANY
#define Xm3D_ONE_OF_MANY Sg3D_ONE_OF_MANY

#define XmNOT_ADJACENT SgNOT_ADJACENT
#define XmLEFT_ADJACENT SgLEFT_ADJACENT
#define XmRIGHT_ADJACENT SgRIGHT_ADJACENT
#define XmTOP_ADJACENT SgTOP_ADJACENT
#define XmBOTTOM_ADJACENT SgBOTTOM_ADJACENT
#define XmNORMAL_ARROWS SgNORMAL_ARROWS
#define XmROTATE_ARROWS SgROTATE_ARROWS
#define XmNO_THUMB_WHEN_EMPTY SgNO_THUMB_WHEN_EMPTY

#ifndef XmNmenuBarRepeatTimeout
#define XmNmenuBarRepeatTimeout SgNmenuBarRepeatTimeout
#endif
#ifndef XmCMenuBarRepeatTimeout
#define XmCMenuBarRepeatTimeout SgCMenuBarRepeatTimeout
#endif

/* ScrollBar.h */
#ifndef XmNarrowsAdjacent
#define XmNarrowsAdjacent SgNarrowsAdjacent
#endif

#ifndef XmCarrowLayout
#define XmCarrowLayout SgCarrowLayout
#endif

#ifndef XmRArrowType
#define XmRArrowType SgRArrowType
#endif

#ifndef XmNarrowsType
#define XmNarrowsType SgNarrowType
#endif

/* SgStrDefs.h */
#ifndef XmRIndPixel
#define XmRIndPixel SgRIndPixel
#endif
#ifndef XmRSelectPixel
#define XmRSelectPixel SgRSelectPixel
#endif
#ifndef XmRArrowType
#define XmRArrowType SgRArrowType
#endif
#ifndef XmNindicatorBackground
#define XmNindicatorBackground SgNindicatorBackground
#endif

#endif /* _SGIMOTIF_OBSOLETE_API */

#ifdef __cplusplus
}
#endif

#endif /* _SGIMOTIF */

#endif /* SGI_API_H */
